function renderTpl(tpl, op) {
	return tpl.replace(/\{%\=(\w+)%\}/g, function(e1, e2) { return op[e2] != null ? op[e2] : '';});
}

$(function(){
	$("img[isrc]").each(function(){
		this.setAttribute("src",this.getAttribute("isrc"))
	})
})

var $liI = $(".loading .loadbg").children('i');
var jj=-1, iLen = $liI.length;
function test(){
    jj++;
    for(jj; jj<iLen ;jj++){
        $liI.eq(jj).addClass('void');
        break;
    }
    if(jj==iLen) {
    	$liI.removeClass('void');
    	jj=-1;
    }
}
var test2 = setInterval(test,30);

var orgUrls = [];
var getSplitUrls = function(_maxNum, _urls){
	if(_maxNum >= _urls.length){
		return _urls;
	}

	var splitUrls = [],totalNum=_urls.length-1;
	var numKeyvalue = {}, numCount = 0;
	while(true){
		var num = Math.ceil(Math.random()*totalNum);
		if(numKeyvalue[num] == undefined){
			splitUrls.push(_urls[num]);
			numKeyvalue[num]=0;
			numCount++;
		}
		if(numCount >= _maxNum){
			break;
		}
	}
	return splitUrls;
}
/**
 * 测试域名
 * @param {Array} urls 域名地址
 */
var SpeedTest = function(urls){
	orgUrls   = urls;
	urls      = getSplitUrls(16, urls);

	var init  = function(){
		this.complete      = [],                      //已响应的域名
		this.completeKeyvalue = {},
		this.error         = [],                      //已响应的错误域名
		this.errorKeyvalue = {},
		this.totalCount    = urls.length,             //需要检测域名的总数
		this.$listDomain   = $("#listDomain");        //域名列表
		this.$bestLine     = $("#bestLine");
		this.$bestLineTop     = $("#bestLineTop");    //优先域名容器
		this.domainResponseTpl = $("#domainResponseTpl").html();     //域名响应模板
		this.domainValidTpl    = $("#domainValidTpl").html();//有效域名模板
		this.LineTopNum = 0;                       //设置优先域名个数
		this.displayNumber = 8;                   //列表显示域名数量
		this.initQueryable = false;                //是否已进行初始化查询
		this.stopCount     = 20;                   //停止记数次数，与timer时间间隔有关
		this.timerInterval = 500;                  //时间间隔

		this.create(urls);
		this.timer(this.timerInterval);
	}

	init.prototype={
		/**
		 * 重新加载
		 */
		refresh:function(){
			Loading.show();
			this.clean();
			urls = getSplitUrls(16, orgUrls);
			this.create(urls);
			this.timer(this.timerInterval);
			this.$bestLine.empty();
		},
		/**
		 * 唯一编码
		 */
		uuid:function(){
			 return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
		        var r = Math.random()*16|0, v = c == 'x' ? r : (r&0x3|0x8);
		        return v.toString(16);
		    });
		},
		/**
		 * 清理
		 */
		clean:function(){
			//this.effCount         = 0;//清理效果计时
			this.complete.length  = 0;//清理已解析成功的域名缓存对象
			this.error.length     = 0;//清理被屏蔽的域名缓存对象
			this.errorKeyvalue    = {};
			this.completeKeyvalue = {};

			//停止更新所有动作
			clearInterval(this.Interval);
		},
		/**
		 * 创建行数据
		 * @param {Array} urls
		 */
		create:function(urls){
			this.$listDomain.empty();

			//定义线路排序 与域名对应并固定
			var xlhz = '零';
			for(var i=0; i<this.totalCount; i++){
				var timelong = new Date().getTime(),
					url      = urls[i].split("}"),
					type     = undefined,
					num      = 0;

				if(url.length == 1){
					url  = url[0];
					type = "{PT";
				}else if(url.length == 2){
					type = url[0];
					url  = url[1];
				}

				this.$listDomain.append(renderTpl(this.domainResponseTpl,{
					type  : type,
					url   : url,
					xlhz  : i+1,
					i     : i,
					stime : timelong,
					uid   : timelong
				}));
			}
		},
		/**
		 * 域名解析完成
		 *
		 * @param {Element} img 检查域名Img元素对象
		 * @param {String}  url 域名地址
		 */
		loadingCompletedad:function(img, url, xlhz){
			this.complete.push({
				"url"  : url,
			  	"xlhz" : xlhz,
			  	"type" : img.getAttribute("type"),
			  	"dif"  : parseFloat(((new Date().getTime()-img.getAttribute("stime"))/1000).toFixed(3))
			});
			//console.log(this.complete)
		},

		/**
		 * 排序.将域名解析时间从小至大排列
		 */
		sort:function(){
			this.complete.sort(function sortNumber(a,b){return a.dif - b.dif});
		},

		/**
		 * 列表域名显示
		 */
		displayDomainList:function(e){
			this.$bestLine.empty();

			var createCount = 1,difSum=0,levelN=0,Lnum = 1,itemNum = this.complete.length-1,classN = '', leveltext='推荐';

			for(var i=0, len=itemNum; i<=len; i++){
				if(i == 0){
					Loading.hide();
					jj=-1;
				}
				//多于10条线路退出创建。最优线路已检测完成，停止域名检测变更
				if(createCount > this.displayNumber){
					this.stopTimer();
					break;
				}

				var item = this.complete[i];
				var leveDif = parseInt(item.dif*10);
				if(this.complete[0].dif*10 > 30){
					leveDif -= 30;
				}
				else if(this.complete[0].dif*10 > 20){
					leveDif -= 20;
				}
				else if(this.complete[0].dif*10 > 10){
					leveDif -= 10;
				}
				levelN = i < 2 ? i<1?25-leveDif:23-leveDif : 22-leveDif;
				Lnum = createCount+this.LineTopNum;

				//给第二三名单独加样式名
				switch(Lnum){
					case 1: classN='liTop'; leveltext='推荐'; break;
					case 2: classN='liTop'; leveltext='推荐'; break;
					case 3: classN='liTop liLine'; leveltext='推荐'; break;
					//case 4: classN='liTop'; leveltext='推荐'; break;
					default: break;
				}

				//判定速度快慢 取最慢和最快之和平均值
				itemNum > 9 ? itemNum = 9 : itemNum ;
				difSum = this.complete[0].dif+this.complete[itemNum].dif;
				if(Lnum>3 && item.dif < difSum*0.6){
					classN='liNormal'; leveltext='较好';
					if(this.complete[0].dif*10 < 10 && item.dif*10>10){
						classN='liSlow'; leveltext='一般';
					}
					else if(this.complete[0].dif*10 > 10 && this.complete[0].dif*10 < 20 && item.dif*10 > 20){
						classN='liSlow'; leveltext='一般';
					}
					else if(this.complete[0].dif*10 > 20 && this.complete[0].dif*10 < 30 && item.dif*10 > 30){
						classN='liSlow'; leveltext='一般';
					}
				}
				else if( item.dif > difSum*0.6){
					classN='liSlow'; leveltext='一般';
				}

				this.$bestLine.append(renderTpl(this.domainValidTpl,{
					url      : item.url,
					aurl     : item.url,
					ms       : item.xlhz,
					i        : i,
					style    : classN,
					dif      : item.dif,
					opentext : "进入",
					leveltext : leveltext,
					uid      : this.uuid()
				}));

				createCount ++;

				$("#huadong1").attr("href",this.complete[0].url);
				$("#huadong2").attr("href",this.complete[0].url+'/static/download/index.html');

				this.showspeed(i,levelN,classN);
			}
		},

		/**
		 * 测度速度条
		 */
		showspeed:function(i,levelN,classN){
			var $liI = $("#valid-item-"+i).children('.url_jindu');
			if(classN.indexOf('liTop')) { levelN-=4; }
			$liI.children('i').each(function(index){
				if(classN == 'liNormal'){
					$(this).addClass('yellow');
				}
				else if(classN == 'liSlow'){
					$(this).addClass('red');
				}
				else {
					$(this).addClass('green');
				}
				if(index>=levelN) return false;
			})
		},

		/**
		 * 定时排列显示顺序
		 */
		timer:function(interval){
			var self = this, timerIntervalCount=1;
			self.Interval = setInterval(function(){
				//结束定时
				if(self.complete.length >= self.totalCount || timerIntervalCount >= self.stopCount){
					self.stopTimer();
				}

				//排序
				self.sort();
				//显示列表域名
				self.displayDomainList(timerIntervalCount);

				timerIntervalCount++;
			},interval)
		},

		checkCount:function(type){
			var count = 0;
			for(var i=0, len=this.complete.length; i<len; i++)
			{
				if(this.complete[i].type == type)
				{
					count++;
				}
			}
			return count;
		},

		/**
		 * 停止域名响应变更运算
		 */
		stopTimer:function(){
			//console.log("--结束计时");
			clearInterval(this.Interval);
		},

		//普通域名
		isPT:function(item){
			return item.type === "{PT";
		},

		//金盾域名
		isJD:function(item){
			return item.type == "{JD";
		},
	}

	return new init();
}

var Vpn={
	show:function(){
		//speedTest.cleanHighlight();
		$(".vpn-container").fadeIn();
	},
	hide:function(){
		$(".vpn-container").fadeOut();
	},
	refresh:function(){
		this.hide();
		speedTest.refresh();
	}
}
var Loading={
	show:function(){
		$(".loading").fadeIn();
		test2 = setInterval(test,30);
	},
	hide:function(){
		$(".loading").fadeOut(0);
		clearInterval(test2);
		setTimeout("$liI.removeClass('void')",1000);
	}
}

/**
 * 创建检测对象
 */
var speedTest = new SpeedTest(Config.DomainUrls);

/**
 * 点击【刷新】按钮
 */
function refresh(){
	Vpn.hide();
	speedTest.refresh();
}

/**
 * 域名解析失败，已被屏蔽。
 *
 * @param {Integer} index 排列位置 n
 * @param {String} url 域名地址
 */
function invalidDomain(url, index, xlhz){
	if(this.speedTest.errorKeyvalue[url] == undefined){
		this.speedTest.errorKeyvalue[url] = 0;
		this.speedTest.error.push({url:url, index:index, xlhz:xlhz});

		//console.log("已被屏蔽总数："+speedTest.error.length + " 总数："+speedTest.totalCount + "  ："+url);

		if(this.speedTest.error.length >= speedTest.totalCount){
			Loading.hide();
			Vpn.show();
		}
	}
}

/**
 * 域名解析成功，缓存数据
 *
 * @param {Element} img 解析组件对象
 * @param {String} msTextID 显示MS组件ID
 * @param {Integer} index 排列位置
 * @param {String} url 域名地址
 */
function rSuccess(img, url, xlhz){
	if(this.speedTest.completeKeyvalue[url] == undefined){
		this.speedTest.completeKeyvalue[url] = 0;
		this.speedTest.loadingCompletedad(img, url, xlhz);
	}
}
